searchNodes=[{"doc":"CAS Strategy for Überauth. Redirects the user to a CAS login page and verifies the Service Ticket the CAS server returns after a successful login. The login flow looks like this: User is redirected to the CAS server's login page by Ueberauth.Strategy.CAS.handle_request!/1 User signs in to the CAS server. CAS server redirects back to the Elixir application, sending a Service Ticket in the URL parameters. This Service Ticket is validated by this Überauth CAS strategy, fetching the user's information at the same time. User can proceed to use the Elixir application. Protocol compliance This strategy only supports a subset of the CAS protocol (version 2.0 and 3.0). Notable, there is no support for proxy-related stuff. More specifically, it supports following CAS URIs: /login The strategy supports calling /login to enable the user to login. This is known as the credential requestor mode in the CAS specification. The strategy only supports the service parameter, and currently does not provide support for renew , gateway or method . /serviceValidate After a successful login, the strategy validates the ticket and retrieves information about the user, as described in the specification . The strategy only supports the required params, service and ticket . There is no support for other params. The validation path can be overridden via configuration to comply with CAS 3.0 and use /p3/serviceValidate . Errors If the login fails, the strategy will fail with error key missing_ticket . If the ticket validation fails, the error key depends: If the response is no valid XML, the error key is malformed_xml . If there is proper error code in the CAS serviceResponse, the error code will be used as error key, while the description will be used as error message. In other cases, the error key will be unknown_error . User data In the ticket validation step (step 4), user information is retrieved. See Ueberauth.Strategy.CAS.User for documentation on accessing CAS attributes. Some attributes are mapped to Überauth info fields, as described below. Default mapping By default, attributes are the same as the Überauth field. For example, the field :last_name will be set from an attribute cas:lastName . This can be disabled by explicitely setting the :sanitize_attribute_names option to false . Configuring Überauth mapping The mapping can be specified in the configuration: config :ueberauth , Ueberauth , providers : [ cas : { Ueberauth.Strategy.CAS , [ base_url : &quot;http://cas.example.com&quot; , validation_path : &quot;/serviceValidate&quot; , callback_url : &quot;http://your-app.example.com/auth/cas/callback&quot; , attributes : %{ last_name : &quot;surname&quot; } , ] } ] Multivalued attributes management By default, only the first value is kept in case of multivalued attributes. This behaviour can be managed with the mutivalued_attributes option, which can be set to :first , :last or :list .","ref":"Ueberauth.Strategy.CAS.html","title":"Ueberauth.Strategy.CAS","type":"module"},{"doc":"","ref":"Ueberauth.Strategy.CAS.html#auth/1","title":"Ueberauth.Strategy.CAS.auth/1","type":"function"},{"doc":"Ueberauth credentials callback. Contains CAS Service Ticket and user roles.","ref":"Ueberauth.Strategy.CAS.html#credentials/1","title":"Ueberauth.Strategy.CAS.credentials/1","type":"function"},{"doc":"","ref":"Ueberauth.Strategy.CAS.html#default_options/0","title":"Ueberauth.Strategy.CAS.default_options/0","type":"function"},{"doc":"Ueberauth extra information callback. Returns all information the CAS server returned about the user that authenticated.","ref":"Ueberauth.Strategy.CAS.html#extra/1","title":"Ueberauth.Strategy.CAS.extra/1","type":"function"},{"doc":"Handle the callback after the CAS Service Ticket has been received or not. The ticket is either present, or missing.","ref":"Ueberauth.Strategy.CAS.html#handle_callback!/1","title":"Ueberauth.Strategy.CAS.handle_callback!/1","type":"function"},{"doc":"Ueberauth cleanup callback. Clears CAS session information from conn .","ref":"Ueberauth.Strategy.CAS.html#handle_cleanup!/1","title":"Ueberauth.Strategy.CAS.handle_cleanup!/1","type":"function"},{"doc":"Ueberauth request handler. Redirects to the CAS server's login page.","ref":"Ueberauth.Strategy.CAS.html#handle_request!/1","title":"Ueberauth.Strategy.CAS.handle_request!/1","type":"function"},{"doc":"Ueberauth user information.","ref":"Ueberauth.Strategy.CAS.html#info/1","title":"Ueberauth.Strategy.CAS.info/1","type":"function"},{"doc":"Ueberauth UID callback.","ref":"Ueberauth.Strategy.CAS.html#uid/1","title":"Ueberauth.Strategy.CAS.uid/1","type":"function"},{"doc":"CAS server API implementation.","ref":"Ueberauth.Strategy.CAS.API.html","title":"Ueberauth.Strategy.CAS.API","type":"module"},{"doc":"Validate a CAS Service Ticket with the CAS server.","ref":"Ueberauth.Strategy.CAS.API.html#validate_ticket/4","title":"Ueberauth.Strategy.CAS.API.validate_ticket/4","type":"function"},{"doc":"Representation of a CAS user with their roles. A CAS serviceResponse is either an error message or a success message. In the success case, the response often contains various attributes containing information about the user. For example, a successful request might look like this: &lt;cas:serviceResponse xmlns:cas=&quot;http://www.yale.edu/tp/cas&quot;&gt; &lt;cas:authenticationSuccess&gt; &lt;cas:user&gt;example&lt;/cas:user&gt; &lt;cas:attributes&gt; &lt;cas:authenticationDate&gt;2016-06-29T21:53:41Z&lt;/cas:authenticationDate&gt; &lt;cas:longTermAuthenticationRequestTokenUsed&gt;false&lt;/cas:longTermAuthenticationRequestTokenUsed&gt; &lt;cas:isFromNewLogin&gt;true&lt;/cas:isFromNewLogin&gt; &lt;cas:email&gt;test@example.com&lt;/cas:email&gt; &lt;/cas:attributes&gt; &lt;/cas:authenticationSuccess&gt; &lt;/cas:serviceResponse&gt; Note that strictly speaking version 2.0 of CAS does not support attributes. The strategy however does not make this distinction: if attributes exist, the strategy will use them. User struct Accessing the attributes is possible by accessing the &quot;attributes&quot; on the raw information. For example: def extract_attributes ( % Ueberauth.Auth { } = auth ) do attributes = auth . extra . raw_info . user . attributes # Do something with the attributes end","ref":"Ueberauth.Strategy.CAS.User.html","title":"Ueberauth.Strategy.CAS.User","type":"module"},{"doc":"Struct containing information about the user. There are two relevant fields: :name - The name returned by the serviceResponse :attributes - Other attributes returned by the serviceResponse","ref":"Ueberauth.Strategy.CAS.User.html#__struct__/0","title":"Ueberauth.Strategy.CAS.User.__struct__/0","type":"function"},{"doc":"","ref":"Ueberauth.Strategy.CAS.User.html#from_xml/2","title":"Ueberauth.Strategy.CAS.User.from_xml/2","type":"function"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"[Feature] Support multivalued attributes (thanks to eric-hostalery ). Previously, if multiple values existed for the same attribute, only the first was used. Now you can configure it to use the first, last or all. In that case, a list will be used instead.","ref":"changelog.html#version-2-3-0","title":"Changelog - Version 2.3.0","type":"extras"},{"doc":"[Feature] Allow skipping attribute sanitization (PR#30, thanks to sebn ) [Fix] Compatability with Überauth 0.7 [Other] Use GA as CI tool [Other] Test against Elixir 1.13","ref":"changelog.html#version-2-2-0","title":"Changelog - Version 2.2.0","type":"extras"},{"doc":"[Feature] Allow configuration of validation path (thanks to Yann VERY ) [Feature] Allow dynamic configuration. This allows dynamically injecting CAS strategies, see PR#11. (thanks to Yann VERY ) [Fix] Fix when :sweet_xml was not in the applications . The library now relies on Elixir to automatically populate the applications . [Other] Test against Elixir 1.11","ref":"changelog.html#version-2-1-0","title":"Changelog - Version 2.1.0","type":"extras"},{"doc":"[Fix] Propagate network errors to Überauth instead of crashing.","ref":"changelog.html#version-2-0-1","title":"Changelog - Version 2.0.1","type":"extras"},{"doc":"Updated all dependencies. More robust error handling. A proper XML parser is now used. Additionally, both the error code and error message are now passed to Überauth (see below). Extract all user attributes. The email and roles fields are replaced by a field attributes . This field contains all attributes from the response. More fields are extracted into the Überauth Info struct. By default, the strategy will insert attributes with the same name (e.g. cas:location will be inserted into location ). This is configurable (see docs). Upgrading from previous versions There are some small incompatibilities in version 2. There are now more error keys. For example, following response: &lt;cas:serviceResponse xmlns:cas=&quot;http://www.yale.edu/tp/cas&quot;&gt; &lt;cas:authenticationFailure code=&quot;INVALID_TICKET&quot;&gt;Ticket 'ST-XXXXX' already consumed&lt;/cas:authenticationFailure&gt; &lt;/cas:serviceResponse&gt; used to result in {&quot;error&quot;, &quot;INVALID_TICKET&quot;} . This will now result in {&quot;INVALID_TICKET&quot;, &quot;Ticket 'ST-XXXXX' already consumed&quot;} . Similarly, there is now a separate error code for malformed XML responses. You should be prepared to handle unknown error keys, since they come from the server. The raw user struct has changed. The fields email and roles have been removed. They can now be found in the new attributes field, which is a map of all attributes. The email no longer defaults to the username, but a cas:email attribute. You can configure which attribute is used, see the docs. The roles field was removed. This didn't actually do anything in the previous version, as it was always the same value. Note that while not supported in the previous version, parsing attributes as json or yaml is still not supported. Since this doesn't appear to be in the spec, it probably won't be supported. You can always read the field from the attributes and parse it yourself.","ref":"changelog.html#version-2-0-0","title":"Changelog - Version 2.0.0","type":"extras"},{"doc":"Central Authentication Service (CAS) strategy for Überauth.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Add :ueberauth and :ueberauth_cas to your list of dependencies in mix.exs : def deps do [ { :ueberauth , &quot;~&gt; 0.7&quot; } , { :ueberauth_cas , &quot;~&gt; 2.0&quot; } ] end Ensure :ueberauth_cas is started before your application: def application do [ applications : [ :ueberauth_cas ] ] end Configure the CAS integration in config/config.exs : config :ueberauth , Ueberauth , providers : [ cas : { Ueberauth.Strategy.CAS , [ base_url : &quot;http://cas.example.com&quot; , callback_url : &quot;http://your-app.example.com/auth/cas/callback&quot; , # sanitize_attribute_names: false, # multivalued_attributes: :first, ] } ] Include the Überauth plug in your controller: defmodule MyApp.AuthController do use MyApp.Web , :controller plug Ueberauth ... end Create the request and callback routes if you haven't already: scope &quot;/auth&quot; , MyApp do pipe_through :browser get &quot;/:provider&quot; , AuthController , :request get &quot;/:provider/callback&quot; , AuthController , :callback end Your controller needs to implement callbacks to deal with Ueberauth.Auth and Ueberauth.Failure responses.","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"Überauth CAS was tested with the Casino CAS server implementation. Please let me know if Überauth CAS is incompatible with your CAS server, and why. The docs contain more information about protocol specifics.","ref":"readme.html#compatibility","title":"Overview - Compatibility","type":"extras"},{"doc":"Copyright (c) 2016 Marcel de Graaf This library is licensed under the MIT license .","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"}]